import numpy as np
import matplotlib.pyplot as plt


class MyPerceptron:

    def __init__(self, learning_rate, feature_length):
        self.learning_rate = learning_rate
        self.w = np.random.random(feature_length + 1)

    def fit(self, X, y):
        bias = np.ones((X.shape[0], 1))
        X = np.append(X, bias, axis=1)
        for row, label in enumerate(y):
            prediction = []  # write your code!
        return

    def predict(self, X):
        X = np.append(X, np.ones((X.shape[0], 1)), axis=1)
        predictions = np.dot(X, self.w)
        index_negative = predictions < 0
        y_prediction = np.ones(y.shape[0])
        y_prediction[index_negative] = -1
        return y_prediction

    def score(self, X, y):
        y_prediction = self.predict(X)
        wrong = np.sum(y != y_prediction)
        return wrong / y.shape[0], wrong


np.random.seed(0)
median = [-1, 0]
sig = [0.2, 0.7]

# exer: more difficult (needs normalization)
#median = [0, 0]
#sig = [0.2, 0.7]
#sig = [0.2, 10.7]

# exer: scale data sig = [0.2, 10.7]
size = (50, 2)
x_neg = np.random.normal(median, sig, size)
x_pos = np.random.normal([1, 1], [0.2, 0.4], size)

plt.scatter(x_neg[:, 0], x_neg[:, 1], c='r', marker='_')
plt.scatter(x_pos[:, 0], x_pos[:, 1], c='b', marker='+')
plt.show()


x = np.append(x_neg, x_pos, axis=0)
y = np.ones(x.shape[0], dtype=np.int8)
y[0:50] = -1
# y[0] = 1
# y[75] = -1
index_row = np.arange(0, x.shape[0])
np.random.shuffle(index_row)
x = x[index_row, :]
y = y[index_row]

# exer: change learning rate
perceptron = MyPerceptron(0.001, x.shape[1])

# exer: normalization
#x_mean = np.mean(x, axis=0)
#x_var = np.var(x, axis=0)
#x = (x - x_mean) / x_var

for i in range(1, 10000):
    perceptron.fit(x, y)
    error, misclassified = perceptron.score(x, y)
    print(f'run {i}  error: {error}, wrong: {misclassified}')
    np.random.shuffle(index_row)
    x = x[index_row, :]
    y = y[index_row]
    if misclassified == 0:
        break
    print(perceptron.w)


neg = y < 0
pos = y > 0
plt.scatter(x[neg, 0], x[neg, 1], c='r', marker='_')
plt.scatter(x[pos, 0], x[pos, 1], c='b', marker='+')
y0 = np.max(x[:, 1])
y1 = np.min(x[:, 1])
x0 = (-y0*perceptron.w[1] - perceptron.w[2])/perceptron.w[0]
x1 = (-y1*perceptron.w[1] - perceptron.w[2])/perceptron.w[0]
plt.plot([x0, x1], [y0, y1], 'g-')
plt.show()

