import tensorflow as tf

from tensorflow.keras import datasets, layers, models
import matplotlib.pyplot as plt

(train_images, train_labels), (test_images, test_labels) = datasets.cifar10.load_data()

# Normalize pixel values to be between 0 and 1
train_images, test_images = train_images / 255.0, test_images / 255.0


model = tf.keras.models.load_model('my-model.sav')
model.summary()  # check model
test_loss, test_acc = model.evaluate(test_images,  test_labels, verbose=2)
print(test_acc)
